searchNodes=[{"doc":"This module provides a means to permit incoming SSH connections based on the remote IP address and TCP port.","ref":"Sshd.AccessList.html","title":"Sshd.AccessList","type":"behaviour"},{"doc":"Returns a boolean which should determine if the remote IP and TCP port, peer_address, is permitted to connect to the SSH server.","ref":"Sshd.AccessList.html#c:permit?/1","title":"Sshd.AccessList.permit?/1","type":"callback"},{"doc":"","ref":"Sshd.AccessList.html#t:ip_address/0","title":"Sshd.AccessList.ip_address/0","type":"type"},{"doc":"","ref":"Sshd.AccessList.html#t:peer_address/0","title":"Sshd.AccessList.peer_address/0","type":"type"},{"doc":"","ref":"Sshd.AccessList.html#t:port_number/0","title":"Sshd.AccessList.port_number/0","type":"type"},{"doc":"Default implementation of Sshd.AccessList, that permits every remote IP address.","ref":"Sshd.AccessList.Default.html","title":"Sshd.AccessList.Default","type":"module"},{"doc":"Callback implementation for Sshd.AccessList.permit?/1.","ref":"Sshd.AccessList.Default.html#permit?/1","title":"Sshd.AccessList.Default.permit?/1","type":"function"},{"doc":"","ref":"Sshd.AccessList.Default.html#t:ip_address/0","title":"Sshd.AccessList.Default.ip_address/0","type":"type"},{"doc":"","ref":"Sshd.AccessList.Default.html#t:peer_address/0","title":"Sshd.AccessList.Default.peer_address/0","type":"type"},{"doc":"","ref":"Sshd.AccessList.Default.html#t:port_number/0","title":"Sshd.AccessList.Default.port_number/0","type":"type"},{"doc":"This module helps to implement password-based authentication.","ref":"Sshd.PasswordAuthenticator.html","title":"Sshd.PasswordAuthenticator","type":"behaviour"},{"doc":"Returns a boolean which determines if the username user with password password is authorized to connect to the SSH server.","ref":"Sshd.PasswordAuthenticator.html#c:authenticate/2","title":"Sshd.PasswordAuthenticator.authenticate/2","type":"callback"},{"doc":"","ref":"Sshd.PasswordAuthenticator.html#t:password/0","title":"Sshd.PasswordAuthenticator.password/0","type":"type"},{"doc":"","ref":"Sshd.PasswordAuthenticator.html#t:username/0","title":"Sshd.PasswordAuthenticator.username/0","type":"type"},{"doc":"Default implementation of password-based authentication.","ref":"Sshd.PasswordAuthenticator.Default.html","title":"Sshd.PasswordAuthenticator.Default","type":"module"},{"doc":"Callback implementation for Sshd.PasswordAuthenticator.authenticate/2.","ref":"Sshd.PasswordAuthenticator.Default.html#authenticate/2","title":"Sshd.PasswordAuthenticator.Default.authenticate/2","type":"function"},{"doc":"","ref":"Sshd.PasswordAuthenticator.Default.html#t:password/0","title":"Sshd.PasswordAuthenticator.Default.password/0","type":"type"},{"doc":"","ref":"Sshd.PasswordAuthenticator.Default.html#t:username/0","title":"Sshd.PasswordAuthenticator.Default.username/0","type":"type"},{"doc":"Default implementation of password-based authentication used during unit-testing.","ref":"Sshd.PasswordAuthenticator.Test.html","title":"Sshd.PasswordAuthenticator.Test","type":"module"},{"doc":"Callback implementation for Sshd.PasswordAuthenticator.authenticate/2.","ref":"Sshd.PasswordAuthenticator.Test.html#authenticate/2","title":"Sshd.PasswordAuthenticator.Test.authenticate/2","type":"function"},{"doc":"","ref":"Sshd.PasswordAuthenticator.Test.html#t:password/0","title":"Sshd.PasswordAuthenticator.Test.password/0","type":"type"},{"doc":"","ref":"Sshd.PasswordAuthenticator.Test.html#t:username/0","title":"Sshd.PasswordAuthenticator.Test.username/0","type":"type"},{"doc":"This module helps with Public Key authentication.","ref":"Sshd.PublicKeyAuthenticator.html","title":"Sshd.PublicKeyAuthenticator","type":"behaviour"},{"doc":"Returns a boolean that determines if the username user, presenting the public_key OpenSSH public key, is authorized to connect to the SSH server.","ref":"Sshd.PublicKeyAuthenticator.html#c:authenticate/3","title":"Sshd.PublicKeyAuthenticator.authenticate/3","type":"callback"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.html#t:opts/0","title":"Sshd.PublicKeyAuthenticator.opts/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.html#t:public_key/0","title":"Sshd.PublicKeyAuthenticator.public_key/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.html#t:username/0","title":"Sshd.PublicKeyAuthenticator.username/0","type":"type"},{"doc":"Implementation of Sshd.PublicKeyAuthenticator which uses the authorized_keys file contained in the HOME directory of the user attempting to enter the SSH server.","ref":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.html","title":"Sshd.PublicKeyAuthenticator.AuthorizedKeys","type":"module"},{"doc":"Callback implementation for Sshd.PublicKeyAuthenticator.authenticate/3.","ref":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.html#authenticate/3","title":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.authenticate/3","type":"function"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.html#t:opts/0","title":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.opts/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.html#t:public_key/0","title":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.public_key/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.html#t:username/0","title":"Sshd.PublicKeyAuthenticator.AuthorizedKeys.username/0","type":"type"},{"doc":"Default implementation of Public Key authentication.","ref":"Sshd.PublicKeyAuthenticator.Default.html","title":"Sshd.PublicKeyAuthenticator.Default","type":"module"},{"doc":"Callback implementation for Sshd.PublicKeyAuthenticator.authenticate/3.","ref":"Sshd.PublicKeyAuthenticator.Default.html#authenticate/3","title":"Sshd.PublicKeyAuthenticator.Default.authenticate/3","type":"function"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.Default.html#t:opts/0","title":"Sshd.PublicKeyAuthenticator.Default.opts/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.Default.html#t:public_key/0","title":"Sshd.PublicKeyAuthenticator.Default.public_key/0","type":"type"},{"doc":"","ref":"Sshd.PublicKeyAuthenticator.Default.html#t:username/0","title":"Sshd.PublicKeyAuthenticator.Default.username/0","type":"type"},{"doc":"The module that encompasses the SSH socket acceptor and its dispatch.","ref":"Sshd.Server.html","title":"Sshd.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Sshd.Server.html#child_spec/1","title":"Sshd.Server.child_spec/1","type":"function"},{"doc":"","ref":"Sshd.Server.html#t:handler/0","title":"Sshd.Server.handler/0","type":"type"},{"doc":"","ref":"Sshd.Server.html#t:ip_address/0","title":"Sshd.Server.ip_address/0","type":"type"},{"doc":"","ref":"Sshd.Server.html#t:peer_address/0","title":"Sshd.Server.peer_address/0","type":"type"},{"doc":"","ref":"Sshd.Server.html#t:port_number/0","title":"Sshd.Server.port_number/0","type":"type"},{"doc":"As incoming SSH connections are accepted, authorized, and request remote shell services; they are passed to the Sshd.ShellHandler.on_shell/4 callback.","ref":"Sshd.ShellHandler.html","title":"Sshd.ShellHandler","type":"behaviour"},{"doc":"User function callback to perform any tasks prior to launching a shell session.","ref":"Sshd.ShellHandler.html#c:on_connect/4","title":"Sshd.ShellHandler.on_connect/4","type":"callback"},{"doc":"User function callback to perform any tasks after a shell session. Will always be called, regardless of disconnect reason.","ref":"Sshd.ShellHandler.html#c:on_disconnect/3","title":"Sshd.ShellHandler.on_disconnect/3","type":"callback"},{"doc":"User function callback to handle incoming shell requests.","ref":"Sshd.ShellHandler.html#c:on_shell/4","title":"Sshd.ShellHandler.on_shell/4","type":"callback"},{"doc":"","ref":"Sshd.ShellHandler.html#t:ip_address/0","title":"Sshd.ShellHandler.ip_address/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.html#t:method/0","title":"Sshd.ShellHandler.method/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.html#t:peer_address/0","title":"Sshd.ShellHandler.peer_address/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.html#t:port_number/0","title":"Sshd.ShellHandler.port_number/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.html#t:ssh_publickey/0","title":"Sshd.ShellHandler.ssh_publickey/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.html#t:username/0","title":"Sshd.ShellHandler.username/0","type":"type"},{"doc":"An example implementation of Sshd.ShellHandler, implementing a very simple Read-Eval-Loop, that does nothing.","ref":"Sshd.ShellHandler.Example.html","title":"Sshd.ShellHandler.Example","type":"module"},{"doc":"Callback implementation for Sshd.ShellHandler.on_connect/4.","ref":"Sshd.ShellHandler.Example.html#on_connect/4","title":"Sshd.ShellHandler.Example.on_connect/4","type":"function"},{"doc":"Callback implementation for Sshd.ShellHandler.on_disconnect/3.","ref":"Sshd.ShellHandler.Example.html#on_disconnect/3","title":"Sshd.ShellHandler.Example.on_disconnect/3","type":"function"},{"doc":"Callback implementation for Sshd.ShellHandler.on_shell/4.","ref":"Sshd.ShellHandler.Example.html#on_shell/4","title":"Sshd.ShellHandler.Example.on_shell/4","type":"function"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:ip_address/0","title":"Sshd.ShellHandler.Example.ip_address/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:method/0","title":"Sshd.ShellHandler.Example.method/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:peer_address/0","title":"Sshd.ShellHandler.Example.peer_address/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:port_number/0","title":"Sshd.ShellHandler.Example.port_number/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:ssh_publickey/0","title":"Sshd.ShellHandler.Example.ssh_publickey/0","type":"type"},{"doc":"","ref":"Sshd.ShellHandler.Example.html#t:username/0","title":"Sshd.ShellHandler.Example.username/0","type":"type"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Migrate to :ssh_file.decode/2 usage. See #11 and #10.","ref":"changelog.html#0-3-0-2023-01-31","title":"Changelog - [0.3.0] - 2023-01-31","type":"extras"},{"doc":"ChangesMisc. documentation changes. Fixes #8.","ref":"changelog.html#0-2-1-2021-07-26","title":"Changelog - [0.2.1] - 2021-07-26","type":"extras"},{"doc":"ChangesUpgraded all dependencies used.Reformatted all source code via mix format command.Resolved a long standing issue with the handler configuration item.Modernization of the source code.","ref":"changelog.html#0-2-0-2021-01-14","title":"Changelog - [0.2.0] - 2021-01-14","type":"extras"},{"doc":"ChangesDo not start sftp protocol by default. Fixes #4.Explicitly pass an empty passphrase to ssh-keygen. Fixes #3.","ref":"changelog.html#0-1-1-2019-11-11","title":"Changelog - [0.1.1] - 2019-11-11","type":"extras"},{"doc":"Initial public release.","ref":"changelog.html#0-1-0-2017-07-17","title":"Changelog - [0.1.0] - 2017-07-17","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Elixir SSHd A very simple way to add SSH server capabilities to an Elixir application.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Simple way of adding SSH version 2.0 server capabilities to one's application, in a secured manner.Acceptable for production systems; due to the secured nature of SSH version 2.0, and the ability of fine-grain access control and authentication methods available.Quick way to drop in to an Elixir or Erlang REPL.Easiest way to create remote accessible custom shell-like programs.","ref":"readme.html#features","title":"Overview - Features","type":"extras"},{"doc":"At runtime :esshd only requires the Erlang runtime and OTP.During the development of :esshd, some third-party software is used and required. This third-party software is ONLY used as supporting material, for quality assurance purposes. No output or files from the third-party software has been included in any final release software.","ref":"readme.html#bom-notice","title":"Overview - BOM notice","type":"extras"},{"doc":"The package can be installed by adding :esshd to your list of dependencies in mix.exs:def deps do [ {:esshd, &quot;~&gt; 0.3.0&quot;} ] endAfter adding :esshd as a dependency, ensure it is started before your own application in mix.exs:def application do [ extra_applications: [:esshd] ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"This Elixir application offers a number of use-cases; and we recommend selecting the solution that best matches your project's desired goal.Drop-in Secure Remote Elixir REPLOnce installed, add the following configuration to your project:app_dir = Application.app_dir(:myapp) priv_dir = Path.join([app_dir, &quot;priv&quot;]) config :esshd, enabled: true, priv_dir: priv_dir, handler: :elixir, port: 10_022, public_key_authenticator: &quot;Sshd.PublicKeyAuthenticator.AuthorizedKeys&quot;Once the above configuration is added, your application will require OpenSSH compatible SSH host keys and an authorized_keys file stored inside of your application's priv directory.To generate the needed OpenSSH host keys, change in to your application's priv directory and execute an appropriate command. An example of such command sequences are as follows:$ [ -d priv ] || mkdir priv $ chmod 700 priv $ cd priv $ ssh-keygen -N &quot;&quot; -b 256 -t ecdsa -f ssh_host_ecdsa_key $ ssh-keygen -N &quot;&quot; -b 1024 -t dsa -f ssh_host_dsa_key $ ssh-keygen -N &quot;&quot; -b 2048 -t rsa -f ssh_host_rsa_key $ echo 127.0.0.1,127.0.0.1 `cat ssh_host_ecdsa_key.pub` &gt; known_hosts $ chmod 644 known_hostsFinally, add all OpenSSH public keys to be accepted in to the authorized_keys file within your application's priv directory.Drop-in Secure Remote Erlang REPLOnce installed, add the following configuration to your project:app_dir = Application.app_dir(:myapp) priv_dir = Path.join([app_dir, &quot;priv&quot;]) config :esshd, enabled: true, priv_dir: priv_dir, handler: :erlang, port: 10_022, public_key_authenticator: &quot;Sshd.PublicKeyAuthenticator.AuthorizedKeys&quot;Once the above configuration is added, your application will require OpenSSH compatible SSH host keys and an authorized_keys file stored inside of your application's priv directory.To generate the needed OpenSSH host keys, change in to your application's priv directory and execute an appropriate command. An example of such command sequences are as follows:$ [ -d priv ] || mkdir priv $ chmod 700 priv $ cd priv $ ssh-keygen -N &quot;&quot; -b 256 -t ecdsa -f ssh_host_ecdsa_key $ ssh-keygen -N &quot;&quot; -b 1024 -t dsa -f ssh_host_dsa_key $ ssh-keygen -N &quot;&quot; -b 2048 -t rsa -f ssh_host_rsa_key $ echo 127.0.0.1,127.0.0.1 `cat ssh_host_ecdsa_key.pub` &gt; known_hosts $ chmod 644 known_hostsFinally, add all OpenSSH public keys to be accepted in to the authorized_keys file within your application's priv directory.Custom Access Control and Authorizationesshd was designed around the concept of easily changing the methods employed in each of access control and authorization by changing the utilized &quot;handler&quot; of each component - by way of Elixir Behaviors.The following behaviors exist and may be implemented and easily configured for use, at application boot time.Sshd.AccessList: offers control over the connecting remote IP address and ports, by simple return of a boolean value that states if the remote connection is accepted. While it may seem simplistic, at first, a behavior may be as complex as time- based, quantity of already connected peers, etc.Sshd.PasswordAuthenticator: offers a means for username and password verification. The behavior offers NO throttling or any such complexity and MUST be securely interfaced to a trusted library that performs correct password handling, even under the case of an invalid password - to prevent detection of actual valid user accounts.Sshd.PublicKeyAuthenticator: offers a means for username and public key verification. While many authentication libraries may not offer this ability - when tied to also tasked with password authentication - one could still tie to their user back-end storage to accommodate this behavior. Also, much like password authentication, correct handling it imperative; see above.Sshd.ShellHandler: offers a means for custom, do-it-yourself remote shells, whereby you are in full control, and may implement any IO to-and-from standard input and output streams. An example of such a shell is included, as it is a mildly complex topic.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"The following configuration options are available, with the default setting shown:access_list :: string(Sshd.AccessList.Default): A string containing the fully qualified module that implements the Sshd.AccessList behavior.enabled :: boolean(true): Determines if the SSH server is enabled or not. Useful in complex applications to disable all incoming SSH connection functionality, without a full recompile and deploy.handler :: :erlang | :elixir | {m, f, a}: The handler that should respond to incoming SSH connections. It may be one of the simple atoms, for simplicity; or, it may be a tuple containing a module, function, and arguments. Note that the arguments are not presently used. The module, function, and arguments option must implement the Sshd.ShellHandler behavior.idle_time :: integer(86_400_000 * 3): The amount of time, in milliseconds, an idle connection may remain, before being automatically disconnected. This does not effect actively utilized connections.max_sessions :: integer(50): The maximum number of simultaneous users connected at one time.negotiation_timeout :: integer(11_000): The amount of time, in milliseconds, that a connection has to begin correct phases of entering in to a valid SSH connection, before being flat out disconnected. This setting helps to keep server utilization down due to port scans and other similar problems.parallel_login :: boolean(false): Determines if simultaneous connections are permitted in the authentication phase. This does not effect if multiple users may be connected simultaneously.password_authenticator :: string(Sshd.PasswordAuthenticator.Default): A string containing the fully qualified module that implements the Sshd.PasswordAuthenticator behavior.port :: integer(10_022): The TCP port number of the SSH server process.preferred_algorithms :: tuple: The acceptable hashes, ciphers, and key exchange mechanizisms of the SSH server. The default settings are the same as the underlying default_algorithms/0 function. For information about configuring this complex setting, please read the similarily named configuration option within the function daemon/2.priv_dir :: string(): specifies the location to your own application's priv directory, or any other directory. This directory is utilized for the SSH host keys and is utilized by the Sshd.PublicKeyAuthenticator.AuthorizedKeys module for both user keys and the authorized_keys file.public_key_authenticator :: string(Sshd.PublicKeyAuthenticator.Default): A string containing the fully qualified module that implements the Sshd.PublicKeyAuthenticator behavior.","ref":"readme.html#configuration-options","title":"Overview - Configuration Options","type":"extras"},{"doc":"Copyright (C) 2017-2021 Joseph Benden.Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Overview - License","type":"extras"}]